<?php 
require_once($_SERVER['DOCUMENT_ROOT'].'/api/lib/database.class.php');
require_once $_SERVER['DOCUMENT_ROOT'].'/vendor/autoload.php';

use Carbon\Carbon;
class Folders
{
    private $db;
    private $id;
    private $data;

    public function __construct($id=null)
    {
        $this->db = database::getconnection();
        if($id!=null)
        {
            $this->id = $id;
            $this->refresh();
        }
    }

    public function refresh()
    {
        $query = "SELECT * FROM `folders` WHERE `id` = '$this->id';";
            $result = $this->db->query($query);
            if($result->num_rows>0)
            {
                $this->data = $result->fetch_assoc();
                if ($this->getOwner() != $_SESSION['username']) {
                    throw new Exception("Unauthorized");
                }
                $this->id = $this->data["id"];
            }
            else{
                throw new Exception("folder not found");
            }
    }

    
    public function getId()
    {
        if($this->id){
            return $this->data["id"];
        }
    }

    public function getOwner()
    {
        if($this->id and isset($this->data["owner"])){
            return $this->data["owner"];
        }
    }

    public function created_at()
    {
        if($this->id and isset($this->data["created_at"])){
            $c = new Carbon($this->data["created_at"]);
            return $c->diffForHumans();
        }
    }

    public function rename($name)
    {
        if($this->id)
        {
        $query = "UPDATE `folders` SET `name` = '$name' WHERE (`id` = '$this->id');";
        $result = $this->db->query($query);
        $this->refresh();
        if($result){
            return true;
        }
        }
        else{
            throw new Exception("Note not loaded");
        }

    }

    public function countNotes(){
        $query = "SELECT COUNT(*) FROM notes WHERE folder_id = '$this->id' and owner ='$_SESSION[username]';";
        $result = $this->db->query($query);
        if($result->num_rows>0){
            $data = $result->fetch_assoc();
            return $data['COUNT(*)'];
        }
        else{
            throw new Exception('something wrong');
        }
    }

    public function create($name='new folder')
    {
        if(isset($_SESSION['username']) and strlen($name)<=45)
        {
            $query = "INSERT INTO `folders` (`name`, `owner`, `created_at`)
            VALUES ('$name','$_SESSION[username]', now());";
            $result = $this->db->query($query);
            if($result){
                $this->id = $this->db->insert_id;
                return $this->id;
            }
            else{
                throw new Exception("something went wrong");
            }
        }else{
            throw new Exception("cannot create note");
        }
    }

    public function getAllNotes(){
        $query = "SELECT * FROM notes WHERE folder_id=$this->id and owner ='$_SESSION[username]'";
        $result = $this->db->query($query);
        if($result){
            $data = $result->fetch_all(MYSQLI_ASSOC);
            for($i=0; $i<count($data); $i++){
                $c_at = $data[$i]['created_at'];
                $u_at = $data[$i]['updated_at'];
                $c_c = new Carbon($c_at);
                $u_c = new Carbon($u_at);
                $data[$i]['created'] = $c_c->diffForHumans();
                $data[$i]['updated'] = $u_c->diffForHumans();
            }
            return $data;
        } else {
            return [];
        }
    }

    public function delete(){
        if(isset($_SESSION['username']) and $this->getOwner() == $_SESSION['username']){
            $notes = $this->getAllNotes();
            foreach($notes as $note){
                $n = new Notes($note['id']);
                $n->delete();
            }

            if($this->id){
                $query = "DELETE FROM `folders` WHERE (`id` = '$this->id');";
                $result = $this->db->query($query);
                return $result;
            } else {
                throw new Exception("Folder not loaded");
            }
        } else {
            throw new Exception("Unable to delete");
        }
    }


    public static function getAllfolders()
    {
        $db = database::getconnection();
        $query = "SELECT * FROM folders WHERE owner='$_SESSION[username]'";
        $result = $db->query($query);
        if($result){
            $data = $result->fetch_all(MYSQLI_ASSOC);
            for($i=0; $i<count($data); $i++){
                $date = $data[$i]['created_at'];
                $c = new Carbon($date);
                $data[$i]['created'] = $c->diffForHumans();
            }
            return $data;
        }else{
            return[];
        }
    }

}