<?php
require_once($_SERVER['DOCUMENT_ROOT'].'/api/lib/database.class.php');
require_once $_SERVER['DOCUMENT_ROOT'].'/vendor/autoload.php';

use Carbon\Carbon;
class Notes
{
    private $db;
    private $id;
    private $data;
    public function __construct($id=null)
    {
        $this->db = database::getconnection();
        if($id!=null)
        {
            $this->id = $id;
            $this->refresh();
        }
    }

    public function refresh()
    {
        $query = "SELECT * FROM `notes` WHERE `id` = '$this->id';";
            $result = $this->db->query($query);
            if($result->num_rows>0)
            {
                $this->data = $result->fetch_assoc();
                if ($this->getOwner() != $_SESSION['username']) {
                    throw new Exception("Unauthorized");
                }
                $this->id = $this->data["id"];
            }
            else{
                throw new Exception("Notes not found");
            }
    }

    public function create($title,$body,$folder)
    {
        new Folders($folder);
        if(isset($_SESSION["username"]) and  strlen($title) <= 45)
        {
            $query = "INSERT INTO `notes` (`title`, `body`, `created_at`, `updated_at`, `owner`, `folder_id`)
            VALUES ('$title', '$body', now(), now(), '$_SESSION[username]', '$folder');";
            $result = $this->db->query($query);
            if($result)
            {
                $this->id = $this->db->insert_id;
                $this->refresh();
                return $this->id;
            }
            else{
                throw new Exception("cannot create note");
            }
        }else{
            throw new Exception("something went wrong");
        }
    }

    public function delete()
    {
        if(isset($_SESSION['username']) and $this->getOwner() == $_SESSION['username']){
        $query = "DELETE FROM `notes` WHERE ((`id` = '$this->id'));";
        $result = $this->db->query($query);
        if($result){
            return $result;
        }
        else{
            throw new Exception("Note not loaded");
        }
        }
        else{
           throw new Exception("Unauthorized ".$this->getOwner()); 
        }
    }

    public function setTitle($title){
        if(isset($_SESSION["username"]) and $this->getOwner() == $_SESSION["username"]){
            if($this->id){
            $query = "UPDATE `notes` SET `title` = '$title' WHERE (`id` = '$this->id');";
            $result = $this->db->query($query);
            $this->setUpdate();
            $this->refresh();
            return $result;
            }else{
                throw new Exception("Note not loaded");
            }
        }else{
            throw new Exception("unauthrized");
        }
    }

    public function setBody($body){
        if(isset($_SESSION["username"]) and $this->getOwner() == $_SESSION["username"]){
            if($this->id){
            $query = "UPDATE `notes` SET `body` = '$body' WHERE (`id` = '$this->id');";
            $result = $this->db->query($query);
            $this->setUpdate();
            $this->refresh();
            return $result;
            }else{
                throw new Exception("Note not loaded");
            }
        }else{
            throw new Exception("unauthrized");
        }
    }

    public function setUpdate(){
        if(isset($_SESSION["username"]) and $this->getOwner() == $_SESSION["username"]){
            if($this->id){
            $query = "UPDATE `notes` SET `updated_at` = now() WHERE (`id` = '$this->id');";
            $result = $this->db->query($query);
            $this->refresh();
            return $result;
            }else{
                throw new Exception("Note not loaded");
            }
        }else{
            throw new Exception("unauthrized");
        }
    }

    public function getId()
    {
        if($this->id){
            return $this->data["id"];
        }
    }

    public function getName()
    {
        if($this->id and isset($this->data["name"])){
            return $this->data["name"];
        }
    }

    public function getOwner()
    {
        if($this->id and isset($this->data["owner"])){
            return $this->data["owner"];
        }
    }

    public function getTitle()
    {
        if($this->id and isset($this->data["title"])){
            return $this->data["title"];
        }
    }

    public function getBody()
    {
        if($this->id and isset($this->data["body"])){
            return $this->data["body"];
        }
    }

    public function created_at()
    {
        if($this->id and isset($this->data["created_at"])){
            $c = new Carbon($this->data["created_at"]);
            return $c->diffForHumans();
        }
    }

    public function updated_at()
    {
        if($this->id and isset($this->data["updated_at"])){
            $c = new Carbon($this->data["updated_at"]);
            return $c->diffForHumans();
        }
    }
}