## Get a new Note

### Request
```
  POST /notes/get
  Authorization: Bearer <your_access_token>
```

#### Form Data
| Attribute | Description |
| ------ | ------ |
| `Token` | Need to provide the token which generated during the login |
| `id`   | Need to provide id of that paticular note. |

### Response
There are 3 types of responses.
| Status Code | Description |
| ------ | ------ |
| 200 | success, Notes related to that id will be displayed. |
| 403 | unauthorized user. |
| 400 | Bad Request Format or Not all attributes are available. |


#### Examples
##### 200 OK
```
{
   "title": "hello world"
   "body":  "hi hello world"
   "created": "1 day ago"
}
```
##### 400 Bad Request
```
{
    "error": "Bad request"
}
```

## Edit an existing note

### Request
```
POST /auth/Edit
Authorization: Bearer <your_access_token>
```

#### Form Data
| Attribute | Description |
| ------ | ------ |
| `Note_search_Term` | Need of paticular NoteId (or) Title (or) Body |

| `Token` | Need to provide the token generated during login |

### Response
There are 3 types of responses.
| Status Code | Description |
| ------ | ------ |
| 200 | User can modify the existing data. |
| 403 | unauthorized user. |
| 400 | Bad Request Format or Not all attributes are available. |


#### Examples
##### 200 OK
```
{
    "id": "1"
    "name": "lahtp notes"
    "owner": "lahtp"
    "created_at": "1 day ago"
    "modified_at": "1 hour ago"

}
```
##### 400 Bad Request
```
{
    "error": "Bad request"
}
```

## Delete note

### Request
```
POST /auth/delete
Authorization: Bearer <your_access_token>
```

#### Form Data
| Attribute | Description |
| ------ | ------ |
| `Note_search_Term` | Need of paticular NoteId (or) Title (or) Body |
| `Token` | Need to provide the token generated during login |

### Response
There are 3 types of responses.
| Status Code | Description |
| ------ | ------ |
| 200 | User can modify the existing data. |
| 403 | unauthorized user. |
| 400 | Bad Request Format . |


#### Examples
##### 200 OK
```
{
    "message": "success"
}
```
##### 400 Bad Request
```
{
    "error": "Bad request"
}
```

## get all notes 

### Request
```
POST /auth/get
Authorization: Bearer <your_access_token>
```

#### Form Data
| Attribute | Description |
| ------ | ------ |
| `Note_search_Term` | Need of paticular FolderId (or) Title (or) Body |
| `Token` | Need to provide the token generated during login |

### Response
There are 3 types of responses.
| Status Code | Description |
| ------ | ------ |
| 200 | User can modify the existing data. |
| 403 | unauthorized user. |
| 400 | Bad Request Format . |


#### Examples
##### 200 OK
```
{
    id": "33",
    "title": "Dummy note 1",
    "body": "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin quis convallis erat. Aenean 
             posuere condimentum efficitur.",
    "created": "21 minutes ago",
    "updated": "21 minutes ago"
}

{
    id": "34",
    "title": "Dummy note 2",
    "body": "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin quis convallis erat. Aenean 
             posuere condimentum efficitur.",
    "created": "21 minutes ago",
    "updated": "21 minutes ago"
}
```
##### 400 Bad Request
```
{
    "error": "Bad request"
}
```